(function (global, factory) {
    if (typeof define === "function" && define.amd) {
        define(['exports', 'react', 'react-required-if', 'react-cursor-position', 'react-hover-observer', './LensTop', './LensLeft', './LensRight', './LensBottom', './EnlargedImage', './ImageShape'], factory);
    } else if (typeof exports !== "undefined") {
        factory(exports, require('react'), require('react-required-if'), require('react-cursor-position'), require('react-hover-observer'), require('./LensTop'), require('./LensLeft'), require('./LensRight'), require('./LensBottom'), require('./EnlargedImage'), require('./ImageShape'));
    } else {
        var mod = {
            exports: {}
        };
        factory(mod.exports, global.react, global.reactRequiredIf, global.reactCursorPosition, global.reactHoverObserver, global.LensTop, global.LensLeft, global.LensRight, global.LensBottom, global.EnlargedImage, global.ImageShape);
        global.ReactImageMagnify = mod.exports;
    }
})(this, function (exports, _react, _reactRequiredIf, _reactCursorPosition, _reactHoverObserver, _LensTop, _LensLeft, _LensRight, _LensBottom, _EnlargedImage, _ImageShape) {
    'use strict';

    Object.defineProperty(exports, "__esModule", {
        value: true
    });

    var _react2 = _interopRequireDefault(_react);

    var _reactRequiredIf2 = _interopRequireDefault(_reactRequiredIf);

    var _reactCursorPosition2 = _interopRequireDefault(_reactCursorPosition);

    var _reactHoverObserver2 = _interopRequireDefault(_reactHoverObserver);

    var _LensTop2 = _interopRequireDefault(_LensTop);

    var _LensLeft2 = _interopRequireDefault(_LensLeft);

    var _LensRight2 = _interopRequireDefault(_LensRight);

    var _LensBottom2 = _interopRequireDefault(_LensBottom);

    var _EnlargedImage2 = _interopRequireDefault(_EnlargedImage);

    var _ImageShape2 = _interopRequireDefault(_ImageShape);

    function _interopRequireDefault(obj) {
        return obj && obj.__esModule ? obj : {
            default: obj
        };
    }

    function _classCallCheck(instance, Constructor) {
        if (!(instance instanceof Constructor)) {
            throw new TypeError("Cannot call a class as a function");
        }
    }

    var _createClass = function () {
        function defineProperties(target, props) {
            for (var i = 0; i < props.length; i++) {
                var descriptor = props[i];
                descriptor.enumerable = descriptor.enumerable || false;
                descriptor.configurable = true;
                if ("value" in descriptor) descriptor.writable = true;
                Object.defineProperty(target, descriptor.key, descriptor);
            }
        }

        return function (Constructor, protoProps, staticProps) {
            if (protoProps) defineProperties(Constructor.prototype, protoProps);
            if (staticProps) defineProperties(Constructor, staticProps);
            return Constructor;
        };
    }();

    function _possibleConstructorReturn(self, call) {
        if (!self) {
            throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
        }

        return call && (typeof call === "object" || typeof call === "function") ? call : self;
    }

    function _inherits(subClass, superClass) {
        if (typeof superClass !== "function" && superClass !== null) {
            throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
        }

        subClass.prototype = Object.create(superClass && superClass.prototype, {
            constructor: {
                value: subClass,
                enumerable: false,
                writable: true,
                configurable: true
            }
        });
        if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
    }

    var ReactImageMagnify = function (_React$Component) {
        _inherits(ReactImageMagnify, _React$Component);

        function ReactImageMagnify(props) {
            _classCallCheck(this, ReactImageMagnify);

            var _this = _possibleConstructorReturn(this, (ReactImageMagnify.__proto__ || Object.getPrototypeOf(ReactImageMagnify)).call(this, props));

            _this.state = {
                smallImageWidth: 0,
                smallImageHeight: 0
            };

            _this.onSmallImageLoad = _this.onSmallImageLoad.bind(_this);
            _this.setSmallImageDimensionState = _this.setSmallImageDimensionState.bind(_this);
            return _this;
        }

        _createClass(ReactImageMagnify, [{
            key: 'onSmallImageLoad',
            value: function onSmallImageLoad() {
                if (!this.props.smallImage.isFluidWidth) {
                    return;
                }

                this.setSmallImageDimensionState();
            }
        }, {
            key: 'setSmallImageDimensionState',
            value: function setSmallImageDimensionState() {
                var _smallImageEl = this.smallImageEl;
                var smallImageWidth = _smallImageEl.offsetWidth;
                var smallImageHeight = _smallImageEl.offsetHeight;


                this.setState({
                    smallImageWidth: smallImageWidth,
                    smallImageHeight: smallImageHeight
                });
            }
        }, {
            key: 'componentDidMount',
            value: function componentDidMount() {
                if (this.props.smallImage.isFluidWidth) {
                    this.setSmallImageDimensionState();
                    window.addEventListener('resize', this.setSmallImageDimensionState);
                }
            }
        }, {
            key: 'componentWillUnmount',
            value: function componentWillUnmount() {
                if (this.props.smallImage.isFluidWidth) {
                    window.removeEventListener('resize', this.setSmallImageDimensionState);
                }
            }
        }, {
            key: 'render',
            value: function render() {
                var _this2 = this;

                var _props = this.props;
                var className = _props.className;
                var enlargedImageContainerClassName = _props.enlargedImageContainerClassName;
                var enlargedImageContainerStyle = _props.enlargedImageContainerStyle;
                var enlargedImageClassName = _props.enlargedImageClassName;
                var enlargedImageStyle = _props.enlargedImageStyle;
                var fadeDurationInMs = _props.fadeDurationInMs;
                var hoverDelayInMs = _props.hoverDelayInMs;
                var hoverOffDelayInMs = _props.hoverOffDelayInMs;
                var isSmallImageFluidWidth = _props.smallImage.isFluidWidth;
                var imageClassName = _props.imageClassName;
                var imageStyle = _props.imageStyle;
                var largeImage = _props.largeImage;
                var lensStyle = _props.lensStyle;
                var style = _props.style;
                var enlargedImagePosition = _props.enlargedImagePosition;


                var fluidWidthSmallImage = Object.assign({}, this.props.smallImage, {
                    width: this.state.smallImageWidth,
                    height: this.state.smallImageHeight
                });
                var fixedWidthSmallImage = this.props.smallImage;
                var smallImage = isSmallImageFluidWidth ? fluidWidthSmallImage : fixedWidthSmallImage;

                var cursorOffset = {
                    x: Math.round(smallImage.width / largeImage.width * smallImage.width / 2),
                    y: Math.round(smallImage.height / largeImage.height * smallImage.height / 2)
                };

                var defaultLensStyle = {
                    backgroundColor: 'rgba(0,0,0,.4)'
                };
                if (enlargedImagePosition === 'over') {
                    defaultLensStyle = {};
                }
                var compositLensStyle = Object.assign({}, defaultLensStyle, lensStyle);

                var fluidWidthContainerStyle = {
                    width: 'auto',
                    height: 'auto',
                    fontSize: '0px',
                    position: 'relative'
                };
                var fixedWidthContainerStyle = {
                    width: smallImage.width + 'px',
                    height: smallImage.height + 'px',
                    position: 'relative'
                };
                var priorityContainerStyle = isSmallImageFluidWidth ? fluidWidthContainerStyle : fixedWidthContainerStyle;
                var compositContainerStyle = Object.assign({
                    cursor: 'crosshair'
                }, style, priorityContainerStyle);

                var fluidWidthSmallImageStyle = {
                    width: '100%',
                    height: 'auto',
                    display: 'block'
                };
                var fixedWidthSmallImageStyle = {
                    width: smallImage.width + 'px',
                    height: smallImage.height + 'px'
                };
                var prioritySmallImageStyle = isSmallImageFluidWidth ? fluidWidthSmallImageStyle : fixedWidthSmallImageStyle;
                var compositSmallImageStyle = Object.assign({}, imageStyle, prioritySmallImageStyle);

                return _react2.default.createElement(
                    _reactCursorPosition2.default,
                    {
                        className: className,
                        style: compositContainerStyle
                    },
                    _react2.default.createElement(
                        _reactHoverObserver2.default,
                        {
                            hoverDelayInMs: hoverDelayInMs,
                            hoverOffDelayInMs: hoverOffDelayInMs,
                            onMouseEnter: function onMouseEnter(_ref) {
                                var setIsHovering = _ref.setIsHovering;
                                return setIsHovering();
                            },
                            onMouseLeave: function onMouseLeave(_ref2) {
                                var unsetIsHovering = _ref2.unsetIsHovering;
                                return unsetIsHovering();
                            },
                            onMouseOver: function onMouseOver(_ref3) {
                                var e = _ref3.e;
                                var unsetIsHovering = _ref3.unsetIsHovering;

                                if (e.target.getAttribute('data-hover') === 'false') {
                                    unsetIsHovering();
                                }
                            }
                        },
                        _react2.default.createElement('img', {
                            src: smallImage.src,
                            srcSet: smallImage.srcSet,
                            sizes: smallImage.sizes,
                            alt: smallImage.alt,
                            className: imageClassName,
                            style: compositSmallImageStyle,
                            ref: function ref(el) {
                                return _this2.smallImageEl = el;
                            },
                            onLoad: this.onSmallImageLoad
                        }),
                        _react2.default.createElement(_LensTop2.default, {
                            cursorOffset: cursorOffset,
                            fadeDurationInMs: fadeDurationInMs,
                            smallImage: smallImage,
                            style: compositLensStyle
                        }),
                        _react2.default.createElement(_LensLeft2.default, {
                            cursorOffset: cursorOffset,
                            fadeDurationInMs: fadeDurationInMs,
                            smallImage: smallImage,
                            style: compositLensStyle
                        }),
                        _react2.default.createElement(_LensRight2.default, {
                            cursorOffset: cursorOffset,
                            fadeDurationInMs: fadeDurationInMs,
                            smallImage: smallImage,
                            style: compositLensStyle
                        }),
                        _react2.default.createElement(_LensBottom2.default, {
                            cursorOffset: cursorOffset,
                            fadeDurationInMs: fadeDurationInMs,
                            smallImage: smallImage,
                            style: compositLensStyle
                        }),
                        _react2.default.createElement(_EnlargedImage2.default, {
                            containerClassName: enlargedImageContainerClassName,
                            containerStyle: enlargedImageContainerStyle,
                            cursorOffset: cursorOffset,
                            fadeDurationInMs: fadeDurationInMs,
                            imageClassName: enlargedImageClassName,
                            imageStyle: enlargedImageStyle,
                            largeImage: largeImage,
                            smallImage: smallImage,
                            imagePosition: enlargedImagePosition
                        })
                    )
                );
            }
        }]);

        return ReactImageMagnify;
    }(_react2.default.Component);

    ReactImageMagnify.propTypes = {
        className: _react.PropTypes.string,
        enlargedImageContainerClassName: _react.PropTypes.string,
        enlargedImageContainerStyle: _react.PropTypes.object,
        enlargedImageClassName: _react.PropTypes.string,
        enlargedImageStyle: _react.PropTypes.object,
        fadeDurationInMs: _react.PropTypes.number,
        hoverDelayInMs: _react.PropTypes.number,
        hoverOffDelayInMs: _react.PropTypes.number,
        imageClassName: _react.PropTypes.string,
        imageStyle: _react.PropTypes.object,
        largeImage: _ImageShape2.default,
        lensStyle: _react.PropTypes.object,
        smallImage: _react.PropTypes.shape({
            alt: _react.PropTypes.string,
            isFluidWidth: _react.PropTypes.bool,
            src: _react.PropTypes.string.isRequired,
            srcSet: _react.PropTypes.string,
            sizes: _react.PropTypes.string,
            width: (0, _reactRequiredIf2.default)(_react.PropTypes.number, function (props) {
                return !props.isFluidWidth;
            }),
            height: (0, _reactRequiredIf2.default)(_react.PropTypes.number, function (props) {
                return !props.isFluidWidth;
            })
        }),
        style: _react.PropTypes.object,
        enlargedImagePosition: _react.PropTypes.oneOf(['beside', 'over'])
    };
    ReactImageMagnify.defaultProps = {
        enlargedImagePosition: 'beside',
        fadeDurationInMs: 300,
        hoverDelayInMs: 250,
        hoverOffDelayInMs: 150
    };
    exports.default = ReactImageMagnify;
});